

{-----------------------------------------------------------------------------
 Unit Name: Antialiasing
 Project Name : Superficies
 Author:    Angel Montesinos Amilibia
 05/01/02 
 Purpose:  antialiasing the contour of a surface
-----------------------------------------------------------------------------}
{*-
 * Copyright (c) 2002 Angel Montesinos Amilibia
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *        Version 4.0.0.0
 *}



Unit Antialiasing;
Interface
Uses
  Forms,
  Globals;

Procedure Antialiase(Var Map: Colormapptr);

Implementation
Uses
  sysutils;
Const
  whiteNeg = 199;
  whitePos = 99;

Type
  ColorLine = array[0..24] of Integer;

Var
  AAMap: ColorMapPtr;

Procedure Scanrow(Map: Colormapptr; N: Integer);
Var
  h, hIni, top, i, jump: Integer;
  color, half, a, b, c, cc, cb: Double;
Begin {1}
  h := 1;
  top := kWidthMinus1;
  While h < top do
  Begin {2}
    If (map^[h, n] = 0) then
      Begin {3}
      If (map^[h, n - 1] <> 0) then
        jump := -1
      Else If (map^[h, n + 1] <> 0) then
        jump := 1
        Else
        Begin {4}
          h := h + 1;
          continue;
        End; {4}
      If (map^[h - 1, n + jump] = 0) then
        Begin {4}
          hIni := h;
          Repeat
            h := h + 1
          until (map^[h, n] <> 0) Or (map^[h, n + jump] = 0) Or (h =
          top);
        If (map^[h, n + jump] = 0) then
          Begin {5}
            half := 3.6 / sqr(h - hIni);
            a := (0.5 - hIni) * (h - 0.5) * half;
            b := (h + hIni - 1) * half;
            c := -half;
          For i := hIni to h - 1 do
            Begin {6}
              color := map^[i, n + jump];
              cc := a + i * (b + c * i);
              cb := 1 - cc;
            If color > 99 then
              AAMap^[i, n] := round(color * cc + whiteNeg * cb)
              Else
              AAMap^[i, n] := round(color * cc + whitePos * cb)
            End; {6}
          End {5}
          Else
          Begin {5}
          If (map^[h, n] = 0) then
            h := h + 1;
          If (h - hIni) > 1 then
            Begin {6}
              half := h - hIni;
              a := (h - 0.5) / half;
              b := -1 / half;
            For i := hIni to (h - 1) do
              Begin {7}
                color := map^[i, n + jump];
                cb := a + b * i;
                cc := 1 - cb;
              If color > 99 then
                AAMap^[i, n] := round(color * cc + whiteNeg * cb)
                Else
                AAMap^[i, n] := round(color * cc + whitePos * cb)
              End; {7}
            End; {6}
          End; {5}
        End {if (Ptr(h+jump-1)^ = 0)} {4}
        Else
        Begin {4}
          hIni := h;
          Repeat
            h := h + 1
          until (map^[h, n] <> 0) Or (map^[h, n + jump] = 0) Or (h =
          top);
        if (map^[h, n + jump] = 0) Or (h = top) then
          Begin {5}
          If (h = top) then
            h := h + 1;
          If (h - hIni) > 1 then
            Begin {6}
              half := h - hIni;
              a := (h - 0.5) / half;
              b := -1 / half;
            For i := hIni to (h - 1) do
              Begin {7}
                color := map^[i, n + jump];
                cc := a + b * i;
                cb := 1 - cc;
              If color > 99 then
                AAMap^[i, n] := round(color * cc + whiteNeg * cb)
                Else
                AAMap^[i, n] := round(color * cc + whitePos * cb)
              End; {7}
            End; {6}
          End {5}
        Else If (map^[h, n + jump] <> 0) then
          Begin {5}
            half := 3.6 / sqr(h - hIni);
            a := (0.5 - hIni) * (h - 0.5) * half;
            b := (h + hIni - 1) * half;
            c := -half;
          For i := hIni to h - 1 do
            Begin {6}
              color := map^[i, n + jump];
              cb := a + i * (b + c * i);
              cc := 1 - cb;
            If color > 99 then
              AAMap^[i, n] := round(color * cc + whiteNeg * cb)
              Else
              AAMap^[i, n] := round(color * cc + whitePos * cb)
            End; {6}
          End {5}
          Else
        End {if (Ptr(h+jump-1)^ <> 0)} {4}
      End {3}
      Else
      h := h + 1;
    End; {2}
End; {1}

Procedure Scancolumn(Map: Colormapptr; N: Integer);
Var
  v, vIni, top, i, jump: Integer;
  color, half, a, b, c, cc, cb: Double;
Begin {1}
  v := 1;
  top := kHeightMinus1;
  While v < top do
  Begin {2}
    If (map^[n, v] = 0) then
      Begin {3}
      If (map^[n - 1, v] <> 0) then
        jump := -1
      Else If (map^[n + 1, v] <> 0) then
        jump := 1
        Else
        Begin {4}
          inc(v);
          continue;
        End; {4}
      If (map^[n + jump, v - 1] = 0) then
        Begin {4}
          vIni := v;
          Repeat
            inc(v)
          until (map^[n, v] <> 0) Or (map^[n + jump, v] = 0) Or (v =
          top);
        If (map^[n + jump, v] = 0) then
          Begin {5}
            half := 3.6 / sqr(v - vIni);
            a := (0.5 - vIni) * (v - 0.5) * half;
            b := (v + vIni - 1) * half;
            c := -half;
          For i := vIni to v - 1 do
            Begin {6}
              color := map^[n + jump, i];
              cc := a + i * (b + c * i);
              cb := 1 - cc;
            If color > 99 then
              AAMap^[n, i] := round(color * cc + whiteNeg * cb)
              Else
              AAMap^[n, i] := round(color * cc + whitePos * cb)
            End; {6}
          End {5}
          Else
          Begin {5}
          If (map^[n, v] = 0) then
            inc(v);
          If (v - vIni) > 0 then
            Begin {6}
              half := v - vIni;
              a := (v - 0.5) / half;
              b := -1 / half;
            For i := vIni to (v - 1) do
              Begin {7}
                color := map^[n + jump, i];
                cb := a + b * i;
                cc := 1 - cb;
              If color > 99 then
                AAMap^[n, i] := round(color * cc + whiteNeg * cb)
                Else
                AAMap^[n, i] := round(color * cc + whitePos * cb)
              End; {7}
            End; {6}
          End; {5}
        End {4}
        Else
        Begin {4}
          vIni := v;
          Repeat
            inc(v)
          until (map^[n, v] <> 0) Or (map^[n + jump, v] = 0) Or (v =
          top);
        if (map^[n + jump, v] = 0) Or (v = top) then
          Begin {5}
          If (v = top) then
            inc(v);
          If (v - vIni) > 0 then
            Begin {6}
              half := v - vIni;
              a := (v - 0.5) / half;
              b := -1 / half;
            For i := vIni to (v - 1) do
              Begin {7}
                color := map^[n + jump, i];
                cc := a + b * i;
                cb := 1 - cc;
              If color > 99 then
                AAMap^[n, i] := round(color * cc + whiteNeg * cb)
                Else
                AAMap^[n, i] := round(color * cc + whitePos * cb)
              End; {7}
            End; {6}
          End {5}
        Else If (map^[n + jump, v] <> 0) then
          Begin {5}
            half := 3.6 / sqr(v - vIni);
            a := (0.5 - vIni) * (v - 0.5) * half;
            b := (v + vIni - 1) * half;
            c := -half;
          For i := vIni to v - 1 do
            Begin {6}
              color := map^[n + jump, i];
              cb := a + i * (b + c * i);
              cc := 1 - cb;
            If color > 99 then
              AAMap^[n, i] := round(color * cc + whiteNeg * cb)
              Else
              AAMap^[n, i] := round(color * cc + whitePos * cb)
            End; {6}
          End {5}
          Else
        End {4}
      End {3}
      Else
      inc(v);
    End; {2}
End; {1}

Procedure Antialiase(Var Map: Colormapptr);
Var
  n, i, j: Integer;
Begin {1}
  For i := 0 to kWidthMinus1 do
  For j := 0 to kHeightMinus1 do
    AAMap^[i, j] := map^[i, j];
  For n := 1 to kHeight - 2 do
    ScanRow(map, n);
  For n := 1 to kWidth - 2 do
    ScanColumn(map, n);
  For i := 0 to kWidthMinus1 do
  For j := 0 to kHeightMinus1 do
    map^[i, j] := AAmap^[i, j];
End; {1}

Procedure Createmap;
Begin {1}
  New(AAMap);
  If AAMap = nil then
    Application.Terminate;
End; {1}

Procedure Disposemap;
Begin {1}
  If AAMap <> nil then
    Dispose(AAMap);
End; {1}

initialization
CreateMap;

finalization
DisposeMap;

End.
